<template>
  <div class="pagination">
      <router-link v-if="currentPage > 1" :to="{ path: 'blog', query: { page: (parseInt(currentPage) - 1) } }" class="pagination--prev">
          Previous
      </router-link>
      <router-link class="pagination--page" :to="{ path: 'blog', query: { page: 1 } }" :class="{ 'pagination--page-active': (currentPage == 1) }">1</router-link>
      <span class="pagination--page" v-if="pages[0] > 2">...</span>
      <router-link v-for="p in pages" :key="'p-'+p" :to="{ path: 'blog', query: { page: p } }" class="pagination--page" :class="{ 'pagination--page-active': (currentPage == p) }">{{ p }}</router-link>
      <span class="pagination--page" v-if="pages[pages.length - 1] < (totalPages - 1)">...</span>
      <router-link class="pagination--page pagination--page-last" :to="{ path: 'blog', query: { page: totalPages } }" :class="{ 'pagination--page-active': (currentPage == totalPages) }">{{ totalPages }}</router-link>
      <router-link v-if="currentPage < totalPages" :to="{ path: 'blog', query: { page: (parseInt(currentPage) + 1) } }" class="pagination--next">
          Next
      </router-link>
  </div>
</template>

<script>

export default {
  name: 'Pagination',
  props: ['currentPage', 'totalPages'],
  computed: {
      pages: function(){
          let min = this.currentPage - 3;
          let max = parseInt(this.currentPage)+ 3;
          min = min <= 1 ? 2 : min;
          max = max >= this.totalPages ? (this.totalPages - 1) : max;
          let range = [];
          for(let i = min; i <= max; i++){
              range.push(i);
          }
          return range;
      }
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.pagination {
    margin-bottom: 150px;
    display: flex;
    flex-direction: row;
    align-items: center;
    justify-content: center;
}

.pagination--prev, .pagination--next {
    box-sizing: border-box;
    text-decoration: none;
    padding: 15px 25px;
    border: 1px solid #ccc;
    min-width: 140px;
    border-radius: 25px;
}

.pagination--prev {
    margin-right: 70px;
}
.pagination--next {
    margin-left: 70px;
}

.pagination--page {
    font-size: 16px;
    line-height: 30px;
    margin-right: 25px;
    color: #4e5c66;
}

.pagination--page-last {
    margin-right: 0;
}

.pagination--page-active {
    font-weight: bold;
    color: #3e3be2;
    font-size: 18px;
}
</style>